Name: relic
Version: 0.6.0
Release: 1%{?dist}.56
Summary: A modern research-oriented cryptographic meta-toolkit
License: ASL 2.0 or LGPLv2
URL: https://github.com/relic-toolkit/relic
Source0: https://github.com/relic-toolkit/relic/archive/%{version}/%{name}-%{version}.tar.gz
Patch0: relic-soversion.patch
Patch1: relic-lib_install_dir.patch
Patch2: relic-cmake-config-install.patch
BuildRequires: cmake >= 3.1
BuildRequires: gcc
BuildRequires: pkgconfig(gmp)

%description
RELIC is a modern research-oriented cryptographic meta-toolkit with emphasis
on efficiency and flexibility. RELIC can be used to build efficient and
usable cryptographic toolkits tailored for specific security levels and
algorithmic choices.

This package includes shared libraries.

%package devel
Summary: A modern research-oriented cryptographic meta-toolkit
Requires: %{name}
Requires: gmp-devel

%description devel
RELIC is a modern research-oriented cryptographic meta-toolkit with emphasis
on efficiency and flexibility. RELIC can be used to build efficient and
usable cryptographic toolkits tailored for specific security levels and
algorithmic choices.

This package includes development files.

%package static
Summary: A modern research-oriented cryptographic meta-toolkit
Requires: %{name}-devel

%description static
RELIC is a modern research-oriented cryptographic meta-toolkit with emphasis
on efficiency and flexibility. RELIC can be used to build efficient and
usable cryptographic toolkits tailored for specific security levels and
algorithmic choices.

This package includes static libraries.

%prep
%autosetup -p1

%build
%cmake \
    -DSTLIB=ON \
    -DSHLIB=ON \
    -DSTBIN=OFF \
    -DARITH=gmp \
    -DCHECK=OFF \
    -DALLOC=AUTO \
    -DFP_PRIME=381 \
    -DFP_QNRES=ON \
    -DFP_METHD='INTEG;INTEG;INTEG;MONTY;LOWER;JMPDS;SLIDE' \
    -DEP_PLAIN=OFF \
    -DEP_SUPER=OFF \
    -DMULTI=PTHREAD \
    -DTIMER=CYCLE \
    -DOPSYS=LINUX \
    -DCMAKE_SYSTEM_NAME=Linux \
    -DWSIZE=%{__isa_bits}

%cmake_build

%install
%cmake_install

%check
%ctest

%files
%license LICENSE*
%doc README.md
%{_libdir}/librelic.so.*

%files devel
%license LICENSE*
%doc README.md
%{_includedir}/relic
%{_libdir}/librelic.so
%{_libdir}/cmake/relic/*.cmake

%files static
%license LICENSE*
%doc README.md
%{_libdir}/librelic_s.a
%changelog
* Thu Aug 25 2022 Oleg Girko <ol@infoserver.lv> - 0.6.0-1
- Initial package
